;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: SystemTimer.inc
;;   Version: 1.0, Updated on 2006/05/15 at 15:10:02
;;  Generated by PSoC Designer ???
;;
;;  DESCRIPTION: Assembler declarations for the SleepTimer user module interface
;;               for the 22/24/27/29/42xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2006. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for SystemTimer API's.
;--------------------------------------------------

SystemTimer_INT_REG:                       equ 0x0e0
SystemTimer_INT_MASK:                      equ 0x40

SystemTimer_TICK_CNTR_SIZE:                 equ  2h
SystemTimer_PSOC_TYPE:                      equ  1

IF (SystemTimer_PSOC_TYPE)                  ; 22/24/27/29xxx Family

; Frequency of sleep timer interrupts
SystemTimer_1_HZ:                           equ 0x18
SystemTimer_8_HZ:                           equ 0x10
SystemTimer_64_HZ:                          equ 0x08
SystemTimer_512_HZ:                         equ 0x00
SystemTimer_CLOCK_MASK:                     equ 0x18
ELSE                                        ; 42020 Family

; Frequency of sleep timer interrupts
SystemTimer_1_HZ:                           equ 0x03
SystemTimer_8_HZ:                           equ 0x02
SystemTimer_64_HZ:                          equ 0x01
SystemTimer_512_HZ:                         equ 0x00
SystemTimer_CLOCK_MASK:                     equ 0x03
ENDIF


SystemTimer_FORCE_RELOAD:                   equ 0x01
SystemTimer_WAIT_RELOAD:                    equ 0x00
