	cpu LMM
	.module main.c
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e main _main fV
_main::
	.dbline -1
	.dbline 21
; //----------------------------------------------------------------------------
; // C main line
; //----------------------------------------------------------------------------
; 
; #include <m8c.h>          // part specific constants and macros
; #include "PSoCAPI.h"      // PSoC API definitions for all User Modules
; 
; #include "driverdecl.h"
; #include "CMXSystem.h"
; #include "CMXSystemExtern.h"
; #include "TransferFunction.h"
; 
; #include "cmx.h"
; #include "ProjectProperties.h"
; #include "Custom.h"
; 
; // Channel includes
; 
; 
; void main()
; {
	.dbline 23
;     // Initialize Project
;     M8C_EnableGInt;                            // Turn on interrupts 
		or  F, 01h

	.dbline 24
;     I2C_CFG &= 0xFC;                           // Disable I2C in case it's not used.
	and REG[0xd6],-4
	.dbline 25
;     SystemTimer_Start();
	push X
	xcall _SystemTimer_Start
	.dbline 26
;     SystemTimer_SetInterval(SystemTimer_64_HZ);
	mov A,8
	xcall _SystemTimer_SetInterval
	.dbline 27
;     SystemTimer_EnableInt();
	xcall _SystemTimer_EnableInt
	pop X
	.dbline 33
; 
;     // Initialize Channels
; 
; 
;     // Initialize Variables
; 	SystemVars.ReadOnlyVars.pse_LED_GREEN = 2;
	mov REG[0xd0],>_SystemVars
	mov [_SystemVars],2
	.dbline 36
; 
;     // Driver instantiations
; CMX_BLINKINGLED_Instantiate(&pse_LED_GREEN);
	mov A,>_pse_LED_GREEN
	push A
	mov A,<_pse_LED_GREEN
	push A
	xcall _CMX_BLINKINGLED_Instantiate
	.dbline 37
; CMX_BLINKINGLED_SetValue(&pse_LED_GREEN, (BYTE)SystemVars.ReadOnlyVars.pse_LED_GREEN);
	mov REG[0xd0],>_SystemVars
	mov A,[_SystemVars]
	push A
	mov A,>_pse_LED_GREEN
	push A
	mov A,<_pse_LED_GREEN
	push A
	xcall _CMX_BLINKINGLED_SetValue
	add SP,-5
	.dbline 40
; 
;     // Custom initization code.
;     CustomInit();
	xcall _CustomInit
	xjmp L8
L7:
	.dbline 44
	.dbline 54
	xcall _CustomPostInputUpdate
	.dbline 57
	xcall _TransferFunction
	.dbline 60
	xcall _CustomPreOutputUpdate
	.dbline 63
	mov REG[0xd0],>_SystemVars
	mov A,[_SystemVars]
	push A
	mov A,>_pse_LED_GREEN
	push A
	mov A,<_pse_LED_GREEN
	push A
	xcall _CMX_BLINKINGLED_SetValue
	add SP,-3
	.dbline 65
L8:
	.dbline 43
	xjmp L7
X0:
	.dbline -2
	.dbline 66
;     // End Initialize Project
; 
; 	while(1)
; 	{
;         // Sync loop sample rate
; #if ( SAMPLE_DIVIDER  )
;         SystemTimer_SyncWait(SAMPLE_DIVIDER, SystemTimer_WAIT_RELOAD);
; #endif
; 
; 		// update input variables
; 
; 
;         // Custom Post Input function
;         CustomPostInputUpdate();
; 
; 		// run transfer function and update output variables
; 		TransferFunction();
; 
;         // CustomPreOutputUpdate();
;         CustomPreOutputUpdate();
; 
; 		// set outputs
; 		CMX_BLINKINGLED_SetValue(&pse_LED_GREEN, (BYTE)SystemVars.ReadOnlyVars.pse_LED_GREEN);
; 
; 	}
; }
L6:
	.dbline 0 ; func end
	jmp .
	.dbend
