//----------------------------------------------------------------------------
// DriverDecl.h
//----------------------------------------------------------------------------

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
#include "CMX_BLINKINGLED.h"
#include "CMX_LX1972L.h"

// Driver ID's
#define ID_pse_LED_GREEN 1
#define ID_pse_LightSensor 2

// Channel ID's
#define ID_ADC_00 0
#define ID_DIO_14 0
#define ID_MVOLTS_06 0
#define ID_SHADOWREGS_0 0
#define ID_SHADOWREGS_1 1
#define ID_SHADOWREGS_2 2
#define ID_SHADOWREGS_3 3

// Channel Type maximum count
#define CMX_ADC_CHAN_MAX 1
#define CMX_DIGITAL_IO_CHAN_MAX 1
#define CMX_MVOLTS_IN_CHAN_MAX 1
#define CMX_SHADOW_MAX 4

// Channel Type instantiation count
#define CMX_ADC_CHAN_COUNT 0
#define CMX_DIGITAL_IO_CHAN_COUNT 1
#define CMX_MVOLTS_IN_CHAN_COUNT 1
#define CMX_SHADOW_COUNT 0

// Driver Parameter Block externs
extern CMX_BLINKINGLED_ParameterBlock const pse_LED_GREEN;
extern CMX_LX1972L_ParameterBlock const pse_LightSensor;
