	cpu LMM
	.module cmx_blinkingled.c
	.area text(rom, con, rel)
	.dbfile ./cmx_blinkingled.c
	.dbfunc e CMX_BLINKINGLED_Instantiate _CMX_BLINKINGLED_Instantiate fV
;         PPChan -> X+2
;     Blink_port -> X+1
;      Blink_pin -> X+0
;        pPBlock -> X-5
_CMX_BLINKINGLED_Instantiate::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 43
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:  CMX_BlinkingLed.c
; //  Version: 1.1.0.1, Updated on 2007/05/18 at 17:38:12
; //  Application: PSoC Express 2.0
; //
; //  DESCRIPTION:  This is driver for BLINKINGLED.
; //-----------------------------------------------------------------------------
; //      Copyright (c) Cypress MicroSystems 2004. All Rights Reserved.
; //*****************************************************************************
; //*****************************************************************************
; 
; #include "m8c.h"
; #include "CMX_BlinkingLed.h"
; #include "cmx.h"
; #include "projectproperties.h"
; #include "SystemTimer.h"
; 
; 
; BYTE BlinkingLedState[CMX_BLINKINGLED_COUNT];  // Allocate state byte for each instance
; BYTE BlinkingLedCount[CMX_BLINKINGLED_COUNT];  // Allocate count byte for each instance
;  
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: BLINKINGLED_Instantiate(pBlock)
; //
; //    DESCRIPTION: 
; //      Initialize this instance of the BlinkingLED
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: 
; //    pPBlock  == Pointer to parameter block.
; //
; //  RETURNS: None
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE: 
; //
; ////////////////////////////////////////////////////////////////////////////////
; 
; void CMX_BLINKINGLED_Instantiate(const CMX_BLINKINGLED_ParameterBlock * pPBlock)
; {
	.dbline 48
;     BYTE Blink_pin;
; 	BYTE Blink_port;
; 	BYTE PPChan;
; 
; 	PPChan = DIOChannelPins[(pPBlock->BLINKINGLED_ChannelID)];   // Get pin and port info
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,6
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_DIOChannelPins
	adc [__r0],>_DIOChannelPins
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+2],A
	.dbline 49
; 	Blink_pin = pinlu[(BYTE)(PPChan & 0x0F)];              // Create pin mask
	mov A,[X+2]
	and A,15
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_pinlu
	adc [__r0],>_pinlu
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+0],A
	.dbline 50
; 	Blink_port = portlu[(BYTE)((PPChan & 0xF0) >>4)];      // Extract port address
	mov A,[X+2]
	and A,-16
	asr A
	asr A
	asr A
	asr A
	and A,15
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_portlu
	adc [__r0],>_portlu
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+1],A
	.dbline 51
; 	GlobalSelectDisconnect(Blink_pin,Blink_port);          // Disconnect Global
	push X
	mov A,[X+1]
	push A
	mov A,[X+0]
	pop X
	xcall _GlobalSelectDisconnect
	pop X
	.dbline 53
; 	
; 	DiscreteDriveMode(Blink_pin, Blink_port, pPBlock->BLINKINGLED_DriveMode); // Set mode to Strong
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,4
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	push X
	push A
	mov A,[X+1]
	push A
	mov A,[X+0]
	push A
	xcall _DiscreteDriveMode
	add SP,-3
	pop X
	.dbline -2
	.dbline 54
; }
L2:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l PPChan 2 c
	.dbsym l Blink_port 1 c
	.dbsym l Blink_pin 0 c
	.dbsym l pPBlock -5 pX
	.dbend
	.dbfunc e CMX_BLINKINGLED_SetValue _CMX_BLINKINGLED_SetValue fV
;       bPinPort -> X+1
;      bInstance -> X+0
;          bMode -> X-6
;        pPBlock -> X-5
_CMX_BLINKINGLED_SetValue::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 80
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: BLINKINGLED_SetValue(pPBlock,  bMode)
; //
; //  DESCRIPTION: 
; //    Sets LED mode between Off, On, and Blink.
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: 
; //    pPBlock == Pointer to Parameter block
; //    bMode   == New Mode 
; //               0 = Off
; //               1 = On
; //               2 = Blink
; //
; //
; //  RETURNS: None
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE: 
; //
; ////////////////////////////////////////////////////////////////////////////////
; 
; void CMX_BLINKINGLED_SetValue(const CMX_BLINKINGLED_ParameterBlock * pPBlock, BYTE bMode)
; {
	.dbline 84
;     BYTE bPinPort;
;     BYTE bInstance;
; 
;     bInstance = pPBlock->BLINKINGLED_INSTANCE;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,5
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+0],A
	.dbline 86
;         
;     if (bMode >= 2) {    // If Value is 2 or great, put LED in blink mode.
	cmp [X-6],2
	jc L4
X0:
	.dbline 86
	.dbline 88
; 
;        if ( (SystemTimer_bGetTickCntr() - BlinkingLedCount[bInstance]) >= pPBlock->BLINKINGLED_BlinkRate) {
	push X
	xcall _SystemTimer_bGetTickCntr
	mov REG[0xd0],>__r0
	pop X
	mov [__r0],A
	mov A,[X-4]
	add A,1
	mov [__r3],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r3]
	romx
	pop X
	mov [__r2],A
	mov A,[X+0]
	mov [__r5],A
	mov [__r4],0
	add [__r5],<_BlinkingLedCount
	adc [__r4],>_BlinkingLedCount
	mov A,[__r4]
	mov REG[0xd4],A
	mvi A,[__r5]
	sub [__r0],A
	mov A,[__r0]
	cmp A,[__r2]
	jc L6
X1:
	.dbline 88
	.dbline 89
;           BlinkingLedCount[bInstance] = SystemTimer_bGetTickCntr();
	push X
	xcall _SystemTimer_bGetTickCntr
	mov REG[0xd0],>__r0
	pop X
	mov [__r0],A
	mov A,[X+0]
	mov [__r3],A
	mov [__r2],0
	add [__r3],<_BlinkingLedCount
	adc [__r2],>_BlinkingLedCount
	mov A,[__r2]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 90
;           BlinkingLedState[bInstance] ^= 0x01;
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_BlinkingLedState
	adc [__r0],>_BlinkingLedState
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	dec [__r1]
	mov [__r2],A
	xor [__r2],1
	mov A,[__r0]
	mov REG[0xd5],A
	mov A,[__r2]
	mvi [__r1],A
	.dbline 91
;        }
L6:
	.dbline 92
;        bMode = BlinkingLedState[bInstance];
	mov REG[0xd0],>__r0
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_BlinkingLedState
	adc [__r0],>_BlinkingLedState
	mov A,[__r0]
	mov REG[0xd4],A
	mvi A,[__r1]
	mov [X-6],A
	.dbline 93
;     }
L4:
	.dbline 95
; 
;     bPinPort = DIOChannelPins[(pPBlock->BLINKINGLED_ChannelID)]; 
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,6
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r1],A
	mov [__r0],0
	add [__r1],<_DIOChannelPins
	adc [__r0],>_DIOChannelPins
	mov A,[__r0]
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+1],A
	.dbline 96
; 	if ((pPBlock->BLINKINGLED_DRIVESENSE ^ bMode ) == 0) {   // Set LED to ON or OFF depending on mode.
	mov A,[X-4]
	add A,2
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [__r0],A
	mov A,[X-6]
	xor [__r0],A
	cmp [__r0],0
	jnz L8
	.dbline 96
	.dbline 97
;        DISetPin(bPinPort,1);
	push X
	mov A,1
	push A
	mov A,[X+1]
	pop X
	xcall _DISetPin
	pop X
	.dbline 98
	xjmp L9
L8:
	.dbline 98
	.dbline 99
	push X
	mov A,0
	push A
	mov A,[X+1]
	pop X
	xcall _DISetPin
	pop X
	.dbline 100
L9:
	.dbline -2
	.dbline 101
;     } else {
;        DISetPin(bPinPort,0);
;     }
; }
L3:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l bPinPort 1 c
	.dbsym l bInstance 0 c
	.dbsym l bMode -6 c
	.dbsym l pPBlock -5 pX
	.dbend
	.area data(ram, con, rel)
	.dbfile ./cmx_blinkingled.c
_BlinkingLedCount::
	.byte 0
	.dbsym e BlinkingLedCount _BlinkingLedCount A[1:1]c
	.area data(ram, con, rel)
	.dbfile ./cmx_blinkingled.c
_BlinkingLedState::
	.byte 0
	.dbsym e BlinkingLedState _BlinkingLedState A[1:1]c
