	cpu LMM
	.module cmx_lx1972l.c
	.area text(rom, con, rel)
	.dbfile ./cmx_lx1972l.c
	.dbfunc e CMX_LX1972L_Instantiate _CMX_LX1972L_Instantiate fV
;        thisBLK -> X-5
_CMX_LX1972L_Instantiate::
	.dbline -1
	push X
	mov X,SP
	.dbline 45
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:  CMX_LX1972L.c
; //  Version: 1.0, Updated on 2006/01/28 at 20:15:02
; //  Application: PSoC Express 2.0
; //
; //  DESCRIPTION:  This Driver calls the low level driver and returns the
; //                voltage that corresponds to a given channel.
; //
; //-----------------------------------------------------------------------------
; //      Copyright (c) Cypress MicroSystems 2006. All Rights Reserved.
; //*****************************************************************************
; //*****************************************************************************
; 
; #include "m8c.h"
; #include "CMX_LX1972L.h"
; #include "cmx.h"
; 
; // Channel type header file
; #include "CMX_MVOLTS_IN_CHAN.h"
; 
; // The format of the function should always be the same,
; // no matter what low level driver is used.
; 
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: LX1972L_Instantiate(const CMX_LX1972L_ParameterBlock * thisBLK)
; //
; //  DESCRIPTION:  
; //    This function doesn't do anything at this time, but is placed here
; //    for forward compatibility.
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: 
; //    thisBLK  => Pointer to ParameterBlock for this instance.
; //
; //  RETURNS: None
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE: 
; //
; //-----------------------------------------------------------------------------
; void CMX_LX1972L_Instantiate(const CMX_LX1972L_ParameterBlock * thisBLK)
; {
	.dbline -2
	.dbline 47
;     // Blank function
; }
L2:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l thisBLK -5 pX
	.dbend
	.dbfunc e CMX_LX1972L_GetValue _CMX_LX1972L_GetValue fc
;        lCounts -> X+0
;        thisBLK -> X-5
_CMX_LX1972L_GetValue::
	.dbline -1
	push X
	mov X,SP
	add SP,4
	.dbline 70
; 
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: LX1972L_GetValue(const CMX_LX1972L_ParameterBlock * thisBLK)
; //
; //  DESCRIPTION:  
; //    This function returns a value between 0 and 100 based on the LX1972L
; //    postion.  
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: 
; //    thisBLK  => Pointer to ParameterBlock for this instance.
; //
; //  RETURNS: 
; //      A Byte value between 0 and 100.
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE: 
; //
; //-----------------------------------------------------------------------------
; BYTE CMX_LX1972L_GetValue(const CMX_LX1972L_ParameterBlock * thisBLK)
; {
	.dbline 73
;    long lCounts;
; 
;    lCounts = (long)(iGetAinChanCounts(thisBLK->InPort))*101;  
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	push X
	xcall _iGetAinChanCounts
	mov REG[0xd0],>__r0
	mov [__r0],X
	pop X
	mov [__r3],A
	mov A,[__r0]
	mov [__r2],A
	tst [__r2],-128
	jz X0
	mov [__r1],-1
	mov [__r0],-1
	jmp X1
X0:
	mov REG[0xd0],>__r0
	mov [__r1],0
	mov [__r0],0
X1:
	mov REG[0xd0],>__r0
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	mov A,0
	push A
	push A
	push A
	mov A,101
	push A
	xcall __mul_32X32_32
	add SP,-4
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	.dbline 74
;    lCounts = lCounts / (1 << (CMX_ADC_CHAN_RESOLUTION));
	mov A,0
	push A
	push A
	mov A,4
	push A
	mov A,0
	push A
	mov A,[X+0]
	push A
	mov A,[X+1]
	push A
	mov A,[X+2]
	push A
	mov A,[X+3]
	push A
	xcall __divmod_32X32_32
	pop A
	mov [X+3],A
	pop A
	mov [X+2],A
	pop A
	mov [X+1],A
	pop A
	mov [X+0],A
	add SP,-4
	.dbline 75
;    if (lCounts > 100)  lCounts = 100;                 // Make sure Max is 100
	mov A,100
	sub A,[X+3]
	mov A,0
	sbb A,[X+2]
	mov A,0
	sbb A,[X+1]
	mov A,[X+0]
	xor A,-128
	mov [__rX],A
	mov A,(0 ^ 0x80)
	sbb A,[__rX]
	jnc L4
X2:
	.dbline 75
	mov [X+0],0
	mov [X+1],0
	mov [X+2],0
	mov [X+3],100
L4:
	.dbline 77
; 
;    return((BYTE)lCounts);                              // Convert to BYTE and return
	mov REG[0xd0],>__r0
	mov A,[X+3]
	.dbline -2
L3:
	add SP,-4
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l lCounts 0 L
	.dbsym l thisBLK -5 pX
	.dbend
