//*****************************************************************************
//*****************************************************************************
//  FILENAME:  cmx_pwmvfreq_chan.c
//  @Version@
//  `@PSOC_VERSION`
//
//  DESCRIPTION:  C file for the PWMVFreq channel.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2001-2006. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include "cmx_pwmvfreq_chan.h"

//-----------------------------------------------------------------------------
//  FUNCTION NAME: PWMVFreqSetDutyCycle(BYTE bID, BYTE bDutyCycle, BYTE bCurrPeriod)
//
//  DESCRIPTION:  
//    Sets the duty cycle for the given channel and given period.
//
//-----------------------------------------------------------------------------
//
//  ARGUMENTS: 
//    bID        => Pointer to ParameterBlock for this instance.
//    bDutyCycle => Needed bDutyCycle's vaue for this instance
//    bCurrPeriod => current period's value of this instance.
//
//  RETURNS: None
//
//  SIDE EFFECTS: 
//
//  THEORY of OPERATION or PROCEDURE: 
//
//
//-----------------------------------------------------------------------------
void PWMVFreqSetDutyCycle(BYTE bID, BYTE bDutyCycle, BYTE bCurrPeriod)
{
	BYTE CompareValue;
	if (bDutyCycle > 100)
	{
		bDutyCycle = 100;
	}
	CompareValue = ((int)(bCurrPeriod + 1) * (int)bDutyCycle)/100;
    PWMVFreqSetPulseWidth(bID, CompareValue);
}
