	cpu LMM
	.module cmx_pwmvfreq_chan_c.c
	.area text(rom, con, rel)
	.dbfile ./cmx_pwmvfreq_chan_c.c
	.dbfunc e PWMVFreqSetDutyCycle _PWMVFreqSetDutyCycle fV
;   CompareValue -> X+0
;    bCurrPeriod -> X-6
;     bDutyCycle -> X-5
;            bID -> X-4
_PWMVFreqSetDutyCycle::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 37
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:  cmx_pwmvfreq_chan.c
; //  @Version@
; //  `@PSOC_VERSION`
; //
; //  DESCRIPTION:  C file for the PWMVFreq channel.
; //-----------------------------------------------------------------------------
; //      Copyright (c) Cypress MicroSystems 2001-2006. All Rights Reserved.
; //*****************************************************************************
; //*****************************************************************************
; 
; #include "cmx_pwmvfreq_chan.h"
; 
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: PWMVFreqSetDutyCycle(BYTE bID, BYTE bDutyCycle, BYTE bCurrPeriod)
; //
; //  DESCRIPTION:  
; //    Sets the duty cycle for the given channel and given period.
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: 
; //    bID        => Pointer to ParameterBlock for this instance.
; //    bDutyCycle => Needed bDutyCycle's vaue for this instance
; //    bCurrPeriod => current period's value of this instance.
; //
; //  RETURNS: None
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE: 
; //
; //
; //-----------------------------------------------------------------------------
; void PWMVFreqSetDutyCycle(BYTE bID, BYTE bDutyCycle, BYTE bCurrPeriod)
; {
	.dbline 39
; 	BYTE CompareValue;
; 	if (bDutyCycle > 100)
	mov A,100
	cmp A,[X-5]
	jnc L2
X0:
	.dbline 40
; 	{
	.dbline 41
; 		bDutyCycle = 100;
	mov [X-5],100
	.dbline 42
; 	}
L2:
	.dbline 43
; 	CompareValue = ((int)(bCurrPeriod + 1) * (int)bDutyCycle)/100;
	mov REG[0xd0],>__r0
	mov A,[X-5]
	mov [__r1],A
	mov [__r0],0
	mov A,[X-6]
	mov [__r3],A
	mov [__r2],0
	add [__r3],1
	adc [__r2],0
	mov [__rX],0
	mov [__rY],0
X1:
	cmp [__r2],0
	jnz X4
	cmp [__r3],0
	jz X3
X4:
	and F,-5
	rrc [__r2]
	rrc [__r3]
	jnc X2
	mov REG[0xd0],>__r0
	mov A,[__r1]
	add [__rX],A
	mov A,[__r0]
	adc [__rY],A
X2:
	asl [__r1]
	rlc [__r0]
	jmp X1
X3:
	mov [__r1],[__rX]
	mov [__r0],[__rY]
	mov REG[0xd0],>__r0
	mov A,0
	push A
	mov A,100
	push A
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	xcall __divmod_16X16_16
	pop A
	mov [__r1],A
	pop A
	add SP,-2
	mov A,[__r1]
	mov [X+0],A
	.dbline 44
;     PWMVFreqSetPulseWidth(bID, CompareValue);
	push X
	mov A,[X+0]
	push A
	mov A,[X-4]
	pop X
	xcall _PWMVFreqSetPulseWidth
	pop X
	.dbline -2
	.dbline 45
; }
L1:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l CompareValue 0 c
	.dbsym l bCurrPeriod -6 c
	.dbsym l bDutyCycle -5 c
	.dbsym l bID -4 c
	.dbend
