	cpu LMM
	.module cmx_varfreqpwm.c
	.area text(rom, con, rel)
	.dbfile ./cmx_varfreqpwm.c
	.dbfunc e CMX_VarFreqPWM_Instantiate _CMX_VarFreqPWM_Instantiate fV
;        bPeriod -> X+2
;       Polarity -> X+1
;      bInstance -> X+0
;        thisBLK -> X-5
_CMX_VarFreqPWM_Instantiate::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 42
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:  CMX_VarFreqPWM.c
; //  Version: 1.1, Updated on 2007/04/20 at 14:00:01 
; //  Application: PSoC Express 2.0
; //
; //  DESCRIPTION:  This Driver controls the Variable Frequency PWM parameters
; //				  and returns the period and percent duty cycle for the
; //				  selected channel.
; //-----------------------------------------------------------------------------
; //      Copyright (c) Cypress MicroSystems 2004-2006. All Rights Reserved.
; //*****************************************************************************
; //*****************************************************************************
; 
; #include "m8c.h"
; #include "CMX_VarFreqPWM.h"
; #include "cmx.h"
; 
; // Channel type header file
; #include "cmx_pwmvfreq_chan.h"
; 
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: VarFreqPWM_Instantiate(const CMX_VarFreqPWM_ParameterBlock * thisBLK)
; //
; //  DESCRIPTION: 
; //     VarFreqPWM Initialization
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS: 
; //     thisBLK => Pointer to parameter Block for this instance.
; //
; //  RETURNS: None
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE: Initialization for VarFreqPWM
; //     Initial conditions set based on parameters set in
; //     VarFreqPWM Parameter block
; //-----------------------------------------------------------------------------
; void CMX_VarFreqPWM_Instantiate(const CMX_VarFreqPWM_ParameterBlock * thisBLK)
; {
	.dbline 47
;     BYTE bInstance;
;     BYTE Polarity;
;     BYTE bPeriod;
; 
;     bInstance = thisBLK->VarFreqPWM_ChannelID;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+0],A
	.dbline 48
;     Polarity = thisBLK->VarFreqPWM_Polarity;
	mov A,[X-4]
	add A,2
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+1],A
	.dbline 50
; 
;     PWMVFreqSetPolarity(bInstance,Polarity);
	push X
	mov A,[X+1]
	push A
	mov A,[X+0]
	pop X
	xcall _PWMVFreqSetPolarity
	pop X
	.dbline 52
; 
; 	bPeriod = PWMVFreqGetInitialPeriod(bInstance);
	push X
	mov A,[X+0]
	xcall _PWMVFreqGetInitialPeriod
	mov REG[0xd0],>__r0
	pop X
	mov [X+2],A
	.dbline 54
;     
; 	PWMVFreqSetPeriod(bInstance, 100);
	push X
	mov A,100
	push A
	mov A,[X+0]
	pop X
	xcall _PWMVFreqSetPeriod
	pop X
	.dbline 55
;     PWMVFreqSetDutyCycle(bInstance, 0, bPeriod);
	mov A,[X+2]
	push A
	mov A,0
	push A
	mov A,[X+0]
	push A
	xcall _PWMVFreqSetDutyCycle
	add SP,-3
	.dbline 56
;     PWMVFreqStart(bInstance);
	push X
	mov A,[X+0]
	xcall _PWMVFreqStart
	pop X
	.dbline -2
	.dbline 57
; }
L2:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l bPeriod 2 c
	.dbsym l Polarity 1 c
	.dbsym l bInstance 0 c
	.dbsym l thisBLK -5 pX
	.dbend
	.dbfunc e CMX_VarFreqPWM_SetValue _CMX_VarFreqPWM_SetValue fV
;      bInstance -> X+1
;        bPeriod -> X+0
; bPercentFreqChange -> X-6
;        thisBLK -> X-5
_CMX_VarFreqPWM_SetValue::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 83
; 
; //-----------------------------------------------------------------------------
; //  FUNCTION NAME: VarFreqPWM_SetValue(const CMX_VarFreqPWM_ParameterBlock * thisBLK, BYTE bPercentFreqChange)
; //
; //  DESCRIPTION: 
; //     Sets the current PWM frequency based on the Base Frequency percent value
; //	   given as a parameter.
; //
; //-----------------------------------------------------------------------------
; //
; //  ARGUMENTS:  
; //     thisBLK            => Pointer to parameter Block for this instance.
; //     bPercentFreqChange => Percentage of Base Frequncy to set.
; //
; //  RETURNS: None
; //
; //  SIDE EFFECTS: 
; //
; //  THEORY of OPERATION or PROCEDURE:
; //     Controls the output PWM signal frequency by setting the appropriate
; //	   period value and duty cycle value according to the Base Frequency
; //	   percentage given for the current instance.
; //-----------------------------------------------------------------------------
; 
; void CMX_VarFreqPWM_SetValue(const CMX_VarFreqPWM_ParameterBlock * thisBLK, BYTE bPercentFreqChange)
; {
	.dbline 87
;     BYTE bInstance;
;     BYTE bPeriod;
; 	
; 	bInstance = thisBLK->VarFreqPWM_ChannelID;
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,1
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	mov [X+1],A
	.dbline 89
; 	
; 	if(bPercentFreqChange<50) bPercentFreqChange=50;
	cmp [X-6],50
	jnc L4
X0:
	.dbline 89
	mov [X-6],50
L4:
	.dbline 90
; 	if(bPercentFreqChange>200) bPercentFreqChange=200;
	mov A,-56
	cmp A,[X-6]
	jnc L6
X1:
	.dbline 90
	mov [X-6],-56
L6:
	.dbline 92
; 	
; 	bPeriod = PWMVFreqGetInitialPeriod(bInstance);
	push X
	mov A,[X+1]
	xcall _PWMVFreqGetInitialPeriod
	mov REG[0xd0],>__r0
	pop X
	mov [X+0],A
	.dbline 94
; 	
; 	bPeriod = ((int)bPeriod * 100) / (int)bPercentFreqChange;
	mov A,[X-6]
	mov [__r1],A
	mov [__r0],0
	mov A,[X+0]
	mov [__r3],A
	mov [__r2],0
	mov [__r5],100
	mov [__r4],0
	mov [__rX],0
	mov [__rY],0
X2:
	cmp [__r4],0
	jnz X5
	cmp [__r5],0
	jz X4
X5:
	and F,-5
	rrc [__r4]
	rrc [__r5]
	jnc X3
	mov REG[0xd0],>__r0
	mov A,[__r3]
	add [__rX],A
	mov A,[__r2]
	adc [__rY],A
X3:
	asl [__r3]
	rlc [__r2]
	jmp X2
X4:
	mov [__r3],[__rX]
	mov [__r2],[__rY]
	mov REG[0xd0],>__r0
	mov A,[__r0]
	push A
	mov A,[__r1]
	push A
	mov A,[__r2]
	push A
	mov A,[__r3]
	push A
	xcall __divmod_16X16_16
	pop A
	mov [__r1],A
	pop A
	add SP,-2
	mov A,[__r1]
	mov [X+0],A
	.dbline 96
;    
; 	PWMVFreqSetPeriod(bInstance, bPeriod);
	push X
	mov A,[X+0]
	push A
	mov A,[X+1]
	pop X
	xcall _PWMVFreqSetPeriod
	pop X
	.dbline 97
;     PWMVFreqSetDutyCycle(bInstance, thisBLK->VarFreqPWM_DutyCycle, bPeriod);
	mov A,[X+0]
	push A
	mov REG[0xd0],>__r0
	mov A,[X-4]
	add A,3
	mov [__r1],A
	mov A,[X-5]
	adc A,0
	push X
	mov X,[__r1]
	romx
	pop X
	push A
	mov A,[X+1]
	push A
	xcall _PWMVFreqSetDutyCycle
	add SP,-3
	.dbline -2
	.dbline 98
; }
L3:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l bInstance 1 c
	.dbsym l bPeriod 0 c
	.dbsym l bPercentFreqChange -6 c
	.dbsym l thisBLK -5 pX
	.dbend
