;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: PWMVFREQ_01.inc
;;   Version: 2.5, Updated on 2006/05/15 at 15:09:31
;;  Generated by PSoC Designer ???
;;
;;  DESCRIPTION: Assembler declarations for the PWM8 user module interface
;;               for the 22/24/27/29xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for PWMVFREQ_01 API's.
;--------------------------------------------------

PWMVFREQ_01_CONTROL_REG_START_BIT:         equ 0x01    ; Control register start bit
PWMVFREQ_01_INT_REG:                       equ 0x0e1
PWMVFREQ_01_INT_MASK:                      equ 0x02


;--------------------------------------------------
; Constants for PWMVFREQ_01 user defined values
;--------------------------------------------------

PWMVFREQ_01_PERIOD:                        equ 0x7c
PWMVFREQ_01_PULSE_WIDTH:                   equ 0x64


;--------------------------------------------------
; Register Address Constants for PWMVFREQ_01
;--------------------------------------------------

PWMVFREQ_01_COUNTER_REG:               equ 0x24   ; DR0 Count register
PWMVFREQ_01_PERIOD_REG:                equ 0x25   ; DR1 Period register
PWMVFREQ_01_COMPARE_REG:               equ 0x26   ; DR2 Compare register
PWMVFREQ_01_CONTROL_REG:               equ 0x27   ; Control register
PWMVFREQ_01_FUNC_REG:                  equ 0x24   ; Function register
PWMVFREQ_01_INPUT_REG:                 equ 0x25   ; Input register
PWMVFREQ_01_OUTPUT_REG:                equ 0x26   ; Output register


;--------------------------------------------------
; PWMVFREQ_01 Macro 'Functions'
;--------------------------------------------------

   macro PWMVFREQ_01_Start_M
   or    reg[PWMVFREQ_01_CONTROL_REG],  PWMVFREQ_01_CONTROL_REG_START_BIT
   endm

   macro PWMVFREQ_01_Stop_M
   and   reg[PWMVFREQ_01_CONTROL_REG], ~PWMVFREQ_01_CONTROL_REG_START_BIT
   endm

   macro PWMVFREQ_01_EnableInt_M
   M8C_EnableIntMask PWMVFREQ_01_INT_REG, PWMVFREQ_01_INT_MASK
   endm

   macro PWMVFREQ_01_DisableInt_M
   M8C_DisableIntMask PWMVFREQ_01_INT_REG, PWMVFREQ_01_INT_MASK
   endm


; end of file PWMVFREQ_01.inc
