	cpu LMM
	.module main.c
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e main _main fV
_main::
	.dbline -1
	.dbline 22
; //----------------------------------------------------------------------------
; // C main line
; //----------------------------------------------------------------------------
; 
; #include <m8c.h>          // part specific constants and macros
; #include "PSoCAPI.h"      // PSoC API definitions for all User Modules
; 
; #include "driverdecl.h"
; #include "CMXSystem.h"
; #include "CMXSystemExtern.h"
; #include "TransferFunction.h"
; 
; #include "cmx.h"
; #include "ProjectProperties.h"
; #include "Custom.h"
; 
; // Channel includes
; // ADC_00 Include
; #include "CMX_ADC_CHAN.h"
; 
; void main()
; {
	.dbline 24
;     // Initialize Project
;     M8C_EnableGInt;                            // Turn on interrupts 
		or  F, 01h

	.dbline 25
;     I2C_CFG &= 0xFC;                           // Disable I2C in case it's not used.
	and REG[0xd6],-4
	.dbline 26
;     SystemTimer_Start();
	push X
	xcall _SystemTimer_Start
	.dbline 27
;     SystemTimer_SetInterval(SystemTimer_64_HZ);
	mov A,8
	xcall _SystemTimer_SetInterval
	.dbline 28
;     SystemTimer_EnableInt();
	xcall _SystemTimer_EnableInt
	.dbline 32
; 
;     // Initialize Channels
;     // ADC_00 Initialization  
;     AdcScanReset(); // Initialize ADC scanner
	xcall _AdcScanReset
	.dbline 33
;     ADC10_Start(ADC10_FULLRANGE);     // Start the User Module  
	mov A,3
	xcall _ADC10_Start
	.dbline 34
;     ADC10_iCal(0x1FF, ADC10_CAL_VBG);  // Calibrate the ADC so 1.3V = 0x01FF  
	mov A,3
	push A
	mov A,1
	push A
	mov A,-1
	push A
	xcall _ADC10_iCal
	add SP,-3
	pop X
	.dbline 35
;     bADC_Mode = 1;  // Turn scanning on after calibration
	mov REG[0xd0],>_bADC_Mode
	mov [_bADC_Mode],1
	.dbline 36
;     ADC10_StartADC();
	push X
	xcall _ADC10_StartADC
	pop X
	.dbline 39
; 
;     // Initialize Variables
; 	SystemVars.ReadOnlyVars.pse_Buzzer = 100;
	mov REG[0xd0],>_SystemVars
	mov [_SystemVars+2],100
	.dbline 40
; 	SystemVars.ReadOnlyVars.pse_LED_GREEN = 2;
	mov [_SystemVars],2
	.dbline 41
; 	SystemVars.ReadOnlyVars.pse_LightSensor = 0;
	mov [_SystemVars+1],0
	.dbline 44
; 
;     // Driver instantiations
; CMX_BLINKINGLED_Instantiate(&pse_LED_GREEN);
	mov A,>_pse_LED_GREEN
	push A
	mov A,<_pse_LED_GREEN
	push A
	xcall _CMX_BLINKINGLED_Instantiate
	add SP,-2
	.dbline 45
; CMX_BLINKINGLED_SetValue(&pse_LED_GREEN, (BYTE)SystemVars.ReadOnlyVars.pse_LED_GREEN);
	mov REG[0xd0],>_SystemVars
	mov A,[_SystemVars]
	push A
	mov A,>_pse_LED_GREEN
	push A
	mov A,<_pse_LED_GREEN
	push A
	xcall _CMX_BLINKINGLED_SetValue
	.dbline 47
; // Not require for ID_pse_LightSensor
; CMX_VarFreqPWM_Instantiate(&pse_Buzzer);
	mov A,>_pse_Buzzer
	push A
	mov A,<_pse_Buzzer
	push A
	xcall _CMX_VarFreqPWM_Instantiate
	add SP,-5
	.dbline 50
; 
;     // Custom initization code.
;     CustomInit();
	xcall _CustomInit
	xjmp L12
L11:
	.dbline 54
	.dbline 61
	mov A,>_pse_LightSensor
	push A
	mov A,<_pse_LightSensor
	push A
	xcall _CMX_LX1972L_GetValue
	add SP,-2
	mov REG[0xd0],>_SystemVars
	mov [_SystemVars+1],A
	.dbline 64
	xcall _CustomPostInputUpdate
	.dbline 67
	xcall _TransferFunction
	.dbline 70
	xcall _CustomPreOutputUpdate
	.dbline 73
	mov REG[0xd0],>_SystemVars
	mov A,[_SystemVars+2]
	push A
	mov A,>_pse_Buzzer
	push A
	mov A,<_pse_Buzzer
	push A
	xcall _CMX_VarFreqPWM_SetValue
	.dbline 74
	mov REG[0xd0],>_SystemVars
	mov A,[_SystemVars]
	push A
	mov A,>_pse_LED_GREEN
	push A
	mov A,<_pse_LED_GREEN
	push A
	xcall _CMX_BLINKINGLED_SetValue
	add SP,-6
	.dbline 76
L12:
	.dbline 53
	xjmp L11
X0:
	.dbline -2
	.dbline 77
;     // End Initialize Project
; 
; 	while(1)
; 	{
;         // Sync loop sample rate
; #if ( SAMPLE_DIVIDER  )
;         SystemTimer_SyncWait(SAMPLE_DIVIDER, SystemTimer_WAIT_RELOAD);
; #endif
; 
; 		// update input variables
; 		SystemVars.ReadOnlyVars.pse_LightSensor = CMX_LX1972L_GetValue(&pse_LightSensor);
; 
;         // Custom Post Input function
;         CustomPostInputUpdate();
; 
; 		// run transfer function and update output variables
; 		TransferFunction();
; 
;         // CustomPreOutputUpdate();
;         CustomPreOutputUpdate();
; 
; 		// set outputs
; 		CMX_VarFreqPWM_SetValue(&pse_Buzzer, (BYTE)SystemVars.ReadOnlyVars.pse_Buzzer);
; 		CMX_BLINKINGLED_SetValue(&pse_LED_GREEN, (BYTE)SystemVars.ReadOnlyVars.pse_LED_GREEN);
; 
; 	}
; }
L8:
	.dbline 0 ; func end
	jmp .
	.dbend
